[PATCH v5 0/6] Finish converting git bisect to C part 4

STALE1802d

Revision v5 of 6 in this series.

10 messages, 2 authors, 2021-08-26 · open the first message on its own page

[PATCH v5 0/6] Finish converting git bisect to C part 4

From: Miriam Rubio <hidden>
Date: 2021-08-20 17:23:05

These patches correspond to a fourth part of patch series 
of Outreachy project "Finish converting `git bisect` from shell to C" 
started by Pranit Bauva and Tanushree Tumane
(https://public-inbox.org/git/pull.117.git.gitgitgadget@gmail.com) and
continued by me.

This fourth part is formed by reimplementations of some `git bisect` 
subcommands, addition of tests and removal of some temporary subcommands.

These patch series emails were generated from:
https://gitlab.com/mirucam/git/commits/git-bisect-work-part4-v5.

I would like to thank Johannes Schindelin, Bagas Sanjaya and 
Christian Couder for reviewing this patch series.

Specific changes
----------------
[1/6] t6030-bisect-porcelain: add tests to control bisect run exit cases
* Add evaluation of error code 255 in test 'bisect run fails with exit 
code equals or greater than 128'.
* Remove test with error code smaller than 0.
---

[4/6] bisect--helper: reimplement `bisect_visualize()`shell function in C
* Use strvec_push() instead of strvec_pushl().
---

[5/6] bisect--helper: reimplement `bisect_run` shell function in C
* Add error message.
* Remove exit variable.
* Write contents of bisect_state() in BISECT_RUN file and show to user.
---

Miriam Rubio (3):
  t6030-bisect-porcelain: add tests to control bisect run exit cases
  t6030-bisect-porcelain: add test for bisect visualize
  bisect--helper: retire `--bisect-next-check` subcommand

Pranit Bauva (2):
  run-command: make `exists_in_PATH()` non-static
  bisect--helper: reimplement `bisect_visualize()`shell function in C

Tanushree Tumane (1):
  bisect--helper: reimplement `bisect_run` shell function in C

 builtin/bisect--helper.c    | 157 ++++++++++++++++++++++++++++++++++--
 git-bisect.sh               |  87 +-------------------
 run-command.c               |   2 +-
 run-command.h               |  12 +++
 t/t6030-bisect-porcelain.sh |  18 +++++
 5 files changed, 182 insertions(+), 94 deletions(-)

-- 
2.29.2

[PATCH v5 1/6] t6030-bisect-porcelain: add tests to control bisect run exit cases

From: Miriam Rubio <hidden>
Date: 2021-08-20 17:23:04

There is a gap on bisect run test coverage related with error exits.
Add two tests to control these error cases.

Signed-off-by: Miriam Rubio <redacted>
---
 t/t6030-bisect-porcelain.sh | 11 +++++++++++
 1 file changed, 11 insertions(+)
diff --git a/t/t6030-bisect-porcelain.sh b/t/t6030-bisect-porcelain.sh
index a1baf4e451..e61b8143fd 100755
--- a/t/t6030-bisect-porcelain.sh
+++ b/t/t6030-bisect-porcelain.sh
@@ -962,4 +962,15 @@ test_expect_success 'bisect handles annotated tags' '
 	grep "$bad is the first bad commit" output
 '
 
+test_expect_success 'bisect run fails with exit code equals or greater than 128' '
+	write_script test_script.sh <<-\EOF &&
+	exit 128 >/dev/null
+	EOF
+	test_must_fail git bisect run ./test_script.sh > my_bisect_log.txt &&
+	write_script test_script.sh <<-\EOF &&
+	exit 255 >/dev/null
+	EOF
+	test_must_fail git bisect run ./test_script.sh >> my_bisect_log.txt
+'
+
 test_done
-- 
2.29.2

[PATCH v5 2/6] t6030-bisect-porcelain: add test for bisect visualize

From: Miriam Rubio <hidden>
Date: 2021-08-20 17:23:05

Add a test to control breakages in bisect visualize command.

Signed-off-by: Miriam Rubio <redacted>
---
 t/t6030-bisect-porcelain.sh | 7 +++++++
 1 file changed, 7 insertions(+)
diff --git a/t/t6030-bisect-porcelain.sh b/t/t6030-bisect-porcelain.sh
index e61b8143fd..f13eeac9ce 100755
--- a/t/t6030-bisect-porcelain.sh
+++ b/t/t6030-bisect-porcelain.sh
@@ -973,4 +973,11 @@ test_expect_success 'bisect run fails with exit code equals or greater than 128'
 	test_must_fail git bisect run ./test_script.sh >> my_bisect_log.txt
 '
 
+test_expect_success 'bisect visualize with a filename with dash and space' '
+	echo "My test line" >> -hello\ 2 &&
+	git add -- -hello\ 2 &&
+	git commit --quiet -m "Add test line" -- -hello\ 2 &&
+	git bisect visualize -p -- -hello\ 2 > my_bisect_log.txt
+'
+
 test_done
-- 
2.29.2

[PATCH v5 3/6] run-command: make `exists_in_PATH()` non-static

From: Miriam Rubio <hidden>
Date: 2021-08-20 17:23:07

From: Pranit Bauva <redacted>

Removes the `static` keyword from `exists_in_PATH()` function
and declares the function in `run-command.h` file.
The function will be used in bisect_visualize() in a later
commit.

Mentored by: Christian Couder [off-list ref]
Mentored by: Johannes Schindelin [off-list ref]
Signed-off-by: Tanushree Tumane <redacted>
Signed-off-by: Miriam Rubio <redacted>
---
 run-command.c |  2 +-
 run-command.h | 12 ++++++++++++
 2 files changed, 13 insertions(+), 1 deletion(-)
diff --git a/run-command.c b/run-command.c
index f72e72cce7..390f46819f 100644
--- a/run-command.c
+++ b/run-command.c
@@ -210,7 +210,7 @@ static char *locate_in_PATH(const char *file)
 	return NULL;
 }
 
-static int exists_in_PATH(const char *file)
+int exists_in_PATH(const char *file)
 {
 	char *r = locate_in_PATH(file);
 	int found = r != NULL;
diff --git a/run-command.h b/run-command.h
index af1296769f..54d74b706f 100644
--- a/run-command.h
+++ b/run-command.h
@@ -182,6 +182,18 @@ void child_process_clear(struct child_process *);
 
 int is_executable(const char *name);
 
+/**
+ * Search if a $PATH for a command exists.  This emulates the path search that
+ * execvp would perform, without actually executing the command so it
+ * can be used before fork() to prepare to run a command using
+ * execve() or after execvp() to diagnose why it failed.
+ *
+ * The caller should ensure that file contains no directory separators.
+ *
+ * Returns 1 if it is found in $PATH or 0 if the command could not be found.
+ */
+int exists_in_PATH(const char *file);
+
 /**
  * Start a sub-process. Takes a pointer to a `struct child_process`
  * that specifies the details and returns pipe FDs (if requested).
-- 
2.29.2

[PATCH v5 4/6] bisect--helper: reimplement `bisect_visualize()`shell function in C

From: Miriam Rubio <hidden>
Date: 2021-08-20 17:23:10

From: Pranit Bauva <redacted>

Reimplement the `bisect_visualize()` shell function
in C and also add `--bisect-visualize` subcommand to
`git bisect--helper` to call it from git-bisect.sh.

Mentored-by: Christian Couder [off-list ref]
Mentored-by: Johannes Schindelin [off-list ref]
Signed-off-by: Tanushree Tumane <redacted>
Signed-off-by: Miriam Rubio <redacted>
---
 builtin/bisect--helper.c | 48 +++++++++++++++++++++++++++++++++++++++-
 git-bisect.sh            | 25 +--------------------
 2 files changed, 48 insertions(+), 25 deletions(-)
diff --git a/builtin/bisect--helper.c b/builtin/bisect--helper.c
index f184eaeac6..1e118a966a 100644
--- a/builtin/bisect--helper.c
+++ b/builtin/bisect--helper.c
@@ -30,6 +30,7 @@ static const char * const git_bisect_helper_usage[] = {
 	N_("git bisect--helper --bisect-state (good|old) [<rev>...]"),
 	N_("git bisect--helper --bisect-replay <filename>"),
 	N_("git bisect--helper --bisect-skip [(<rev>|<range>)...]"),
+	N_("git bisect--helper --bisect-visualize"),
 	NULL
 };
 
@@ -1036,6 +1037,44 @@ static enum bisect_error bisect_skip(struct bisect_terms *terms, const char **ar
 	return res;
 }
 
+static int bisect_visualize(struct bisect_terms *terms, const char **argv, int argc)
+{
+	struct strvec args = STRVEC_INIT;
+	int flags = RUN_COMMAND_NO_STDIN, res = 0;
+	struct strbuf sb = STRBUF_INIT;
+
+	if (bisect_next_check(terms, NULL) != 0)
+		return BISECT_FAILED;
+
+	if (!argc) {
+		if ((getenv("DISPLAY") || getenv("SESSIONNAME") || getenv("MSYSTEM") ||
+		     getenv("SECURITYSESSIONID")) && exists_in_PATH("gitk"))
+			strvec_push(&args, "gitk");
+		else {
+			strvec_push(&args, "log");
+			flags |= RUN_GIT_CMD;
+		}
+	} else {
+		if (argv[0][0] == '-') {
+			strvec_push(&args, "log");
+			flags |= RUN_GIT_CMD;
+		} else if (strcmp(argv[0], "tig") && !starts_with(argv[0], "git"))
+			flags |= RUN_GIT_CMD;
+
+		strvec_pushv(&args, argv);
+	}
+
+	strvec_pushl(&args, "--bisect", "--", NULL);
+
+	strbuf_read_file(&sb, git_path_bisect_names(), 0);
+	sq_dequote_to_strvec(sb.buf, &args);
+	strbuf_release(&sb);
+
+	res = run_command_v_opt(args.v, flags);
+	strvec_clear(&args);
+	return res;
+}
+
 int cmd_bisect__helper(int argc, const char **argv, const char *prefix)
 {
 	enum {
@@ -1048,7 +1087,8 @@ int cmd_bisect__helper(int argc, const char **argv, const char *prefix)
 		BISECT_STATE,
 		BISECT_LOG,
 		BISECT_REPLAY,
-		BISECT_SKIP
+		BISECT_SKIP,
+		BISECT_VISUALIZE,
 	} cmdmode = 0;
 	int res = 0, nolog = 0;
 	struct option options[] = {
@@ -1070,6 +1110,8 @@ int cmd_bisect__helper(int argc, const char **argv, const char *prefix)
 			 N_("replay the bisection process from the given file"), BISECT_REPLAY),
 		OPT_CMDMODE(0, "bisect-skip", &cmdmode,
 			 N_("skip some commits for checkout"), BISECT_SKIP),
+		OPT_CMDMODE(0, "bisect-visualize", &cmdmode,
+			 N_("visualize the bisection"), BISECT_VISUALIZE),
 		OPT_BOOL(0, "no-log", &nolog,
 			 N_("no log for BISECT_WRITE")),
 		OPT_END()
@@ -1131,6 +1173,10 @@ int cmd_bisect__helper(int argc, const char **argv, const char *prefix)
 		get_terms(&terms);
 		res = bisect_skip(&terms, argv, argc);
 		break;
+	case BISECT_VISUALIZE:
+		get_terms(&terms);
+		res = bisect_visualize(&terms, argv, argc);
+		break;
 	default:
 		BUG("unknown subcommand %d", cmdmode);
 	}
diff --git a/git-bisect.sh b/git-bisect.sh
index 6a7afaea8d..95f7f3fb8c 100755
--- a/git-bisect.sh
+++ b/git-bisect.sh
@@ -39,29 +39,6 @@ _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
 TERM_BAD=bad
 TERM_GOOD=good
 
-bisect_visualize() {
-	git bisect--helper --bisect-next-check $TERM_GOOD $TERM_BAD fail || exit
-
-	if test $# = 0
-	then
-		if test -n "${DISPLAY+set}${SESSIONNAME+set}${MSYSTEM+set}${SECURITYSESSIONID+set}" &&
-			type gitk >/dev/null 2>&1
-		then
-			set gitk
-		else
-			set git log
-		fi
-	else
-		case "$1" in
-		git*|tig) ;;
-		-*)	set git log "$@" ;;
-		*)	set git "$@" ;;
-		esac
-	fi
-
-	eval '"$@"' --bisect -- $(cat "$GIT_DIR/BISECT_NAMES")
-}
-
 bisect_run () {
 	git bisect--helper --bisect-next-check $TERM_GOOD $TERM_BAD fail || exit
 
@@ -152,7 +129,7 @@ case "$#" in
 		# Not sure we want "next" at the UI level anymore.
 		git bisect--helper --bisect-next "$@" || exit ;;
 	visualize|view)
-		bisect_visualize "$@" ;;
+		git bisect--helper --bisect-visualize "$@" || exit;;
 	reset)
 		git bisect--helper --bisect-reset "$@" ;;
 	replay)
-- 
2.29.2

[PATCH v5 5/6] bisect--helper: reimplement `bisect_run` shell function in C

From: Miriam Rubio <hidden>
Date: 2021-08-20 17:23:14

From: Tanushree Tumane <redacted>

Reimplement the `bisect_run()` shell function
in C and also add `--bisect-run` subcommand to
`git bisect--helper` to call it from git-bisect.sh.

Mentored-by: Christian Couder [off-list ref]
Signed-off-by: Tanushree Tumane <redacted>
Signed-off-by: Miriam Rubio <redacted>
---
 builtin/bisect--helper.c | 102 +++++++++++++++++++++++++++++++++++++++
 git-bisect.sh            |  62 +-----------------------
 2 files changed, 103 insertions(+), 61 deletions(-)
diff --git a/builtin/bisect--helper.c b/builtin/bisect--helper.c
index 1e118a966a..8d33c809aa 100644
--- a/builtin/bisect--helper.c
+++ b/builtin/bisect--helper.c
@@ -18,6 +18,7 @@ static GIT_PATH_FUNC(git_path_bisect_log, "BISECT_LOG")
 static GIT_PATH_FUNC(git_path_head_name, "head-name")
 static GIT_PATH_FUNC(git_path_bisect_names, "BISECT_NAMES")
 static GIT_PATH_FUNC(git_path_bisect_first_parent, "BISECT_FIRST_PARENT")
+static GIT_PATH_FUNC(git_path_bisect_run, "BISECT_RUN")
 
 static const char * const git_bisect_helper_usage[] = {
 	N_("git bisect--helper --bisect-reset [<commit>]"),
@@ -31,6 +32,7 @@ static const char * const git_bisect_helper_usage[] = {
 	N_("git bisect--helper --bisect-replay <filename>"),
 	N_("git bisect--helper --bisect-skip [(<rev>|<range>)...]"),
 	N_("git bisect--helper --bisect-visualize"),
+	N_("git bisect--helper --bisect-run <cmd>..."),
 	NULL
 };
 
@@ -144,6 +146,25 @@ static int append_to_file(const char *path, const char *format, ...)
 	return res;
 }
 
+static int print_file_to_stdout(const char *path)
+{
+	FILE *fp;
+	char c;
+
+	fp = fopen(path, "r");
+	if (!fp)
+		return error_errno(_("cannot open file '%s' in read mode"), path);
+
+	c = fgetc(fp);
+	while (c != EOF) {
+		printf ("%c", c);
+		c = fgetc(fp);
+	}
+
+	fclose(fp);
+	return 0;
+}
+
 static int check_term_format(const char *term, const char *orig_term)
 {
 	int res;
@@ -1075,6 +1096,78 @@ static int bisect_visualize(struct bisect_terms *terms, const char **argv, int a
 	return res;
 }
 
+static int bisect_run(struct bisect_terms *terms, const char **argv, int argc)
+{
+	int res = BISECT_OK;
+	struct strbuf command = STRBUF_INIT;
+	struct strvec args = STRVEC_INIT;
+	struct strvec run_args = STRVEC_INIT;
+	const char *new_state;
+	int temporary_stdout_fd, saved_stdout;
+
+	if (bisect_next_check(terms, NULL))
+		return BISECT_FAILED;
+
+	if (argc)
+		sq_quote_argv(&command, argv);
+	else {
+		error(_("bisect run failed: no command provided."));
+		return BISECT_FAILED;
+	}
+
+	strvec_push(&run_args, command.buf);
+
+	while (1) {
+		strvec_clear(&args);
+
+		printf(_("running %s\n"), command.buf);
+		res = run_command_v_opt(run_args.v, RUN_USING_SHELL);
+
+		if (res < 0 || 128 <= res) {
+			error(_("bisect run failed: exit code %d from"
+				" '%s' is < 0 or >= 128"), res, command.buf);
+			strbuf_release(&command);
+			return res;
+		}
+
+		if (res == 125)
+			new_state = "skip";
+		else new_state = res > 0 ? terms->term_bad : terms->term_good;
+
+		temporary_stdout_fd = open(git_path_bisect_run(), O_CREAT | O_WRONLY | O_TRUNC, 0666);
+		saved_stdout = dup(1);
+		dup2(temporary_stdout_fd, 1);
+
+		res = bisect_state(terms, &new_state, 1);
+
+		dup2(saved_stdout, 1);
+		close(saved_stdout);
+		close(temporary_stdout_fd);
+
+		print_file_to_stdout(git_path_bisect_run());
+
+		if (res == BISECT_ONLY_SKIPPED_LEFT)
+			error(_("bisect run cannot continue any more"));
+		else if (res == BISECT_INTERNAL_SUCCESS_MERGE_BASE) {
+			printf(_("bisect run success"));
+			res = BISECT_OK;
+		} else if (res == BISECT_INTERNAL_SUCCESS_1ST_BAD_FOUND) {
+			printf(_("bisect found first bad commit"));
+			res = BISECT_OK;
+		} else if (res) {
+			error(_("bisect run failed:'git bisect--helper --bisect-state"
+			" %s' exited with error code %d"), args.v[0], res);
+		} else {
+			continue;
+		}
+
+		strbuf_release(&command);
+		strvec_clear(&args);
+		strvec_clear(&run_args);
+		return res;
+	}
+}
+
 int cmd_bisect__helper(int argc, const char **argv, const char *prefix)
 {
 	enum {
@@ -1089,6 +1182,7 @@ int cmd_bisect__helper(int argc, const char **argv, const char *prefix)
 		BISECT_REPLAY,
 		BISECT_SKIP,
 		BISECT_VISUALIZE,
+		BISECT_RUN,
 	} cmdmode = 0;
 	int res = 0, nolog = 0;
 	struct option options[] = {
@@ -1112,6 +1206,8 @@ int cmd_bisect__helper(int argc, const char **argv, const char *prefix)
 			 N_("skip some commits for checkout"), BISECT_SKIP),
 		OPT_CMDMODE(0, "bisect-visualize", &cmdmode,
 			 N_("visualize the bisection"), BISECT_VISUALIZE),
+		OPT_CMDMODE(0, "bisect-run", &cmdmode,
+			 N_("use <cmd>... to automatically bisect."), BISECT_RUN),
 		OPT_BOOL(0, "no-log", &nolog,
 			 N_("no log for BISECT_WRITE")),
 		OPT_END()
@@ -1177,6 +1273,12 @@ int cmd_bisect__helper(int argc, const char **argv, const char *prefix)
 		get_terms(&terms);
 		res = bisect_visualize(&terms, argv, argc);
 		break;
+	case BISECT_RUN:
+		if (!argc)
+			return error(_("bisect run failed: no command provided."));
+		get_terms(&terms);
+		res = bisect_run(&terms, argv, argc);
+		break;
 	default:
 		BUG("unknown subcommand %d", cmdmode);
 	}
diff --git a/git-bisect.sh b/git-bisect.sh
index 95f7f3fb8c..e83d011e17 100755
--- a/git-bisect.sh
+++ b/git-bisect.sh
@@ -39,66 +39,6 @@ _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
 TERM_BAD=bad
 TERM_GOOD=good
 
-bisect_run () {
-	git bisect--helper --bisect-next-check $TERM_GOOD $TERM_BAD fail || exit
-
-	test -n "$*" || die "$(gettext "bisect run failed: no command provided.")"
-
-	while true
-	do
-		command="$@"
-		eval_gettextln "running \$command"
-		"$@"
-		res=$?
-
-		# Check for really bad run error.
-		if [ $res -lt 0 -o $res -ge 128 ]
-		then
-			eval_gettextln "bisect run failed:
-exit code \$res from '\$command' is < 0 or >= 128" >&2
-			exit $res
-		fi
-
-		# Find current state depending on run success or failure.
-		# A special exit code of 125 means cannot test.
-		if [ $res -eq 125 ]
-		then
-			state='skip'
-		elif [ $res -gt 0 ]
-		then
-			state="$TERM_BAD"
-		else
-			state="$TERM_GOOD"
-		fi
-
-		git bisect--helper --bisect-state $state >"$GIT_DIR/BISECT_RUN"
-		res=$?
-
-		cat "$GIT_DIR/BISECT_RUN"
-
-		if sane_grep "first $TERM_BAD commit could be any of" "$GIT_DIR/BISECT_RUN" \
-			>/dev/null
-		then
-			gettextln "bisect run cannot continue any more" >&2
-			exit $res
-		fi
-
-		if [ $res -ne 0 ]
-		then
-			eval_gettextln "bisect run failed:
-'bisect-state \$state' exited with error code \$res" >&2
-			exit $res
-		fi
-
-		if sane_grep "is the first $TERM_BAD commit" "$GIT_DIR/BISECT_RUN" >/dev/null
-		then
-			gettextln "bisect run success"
-			exit 0;
-		fi
-
-	done
-}
-
 get_terms () {
 	if test -s "$GIT_DIR/BISECT_TERMS"
 	then
@@ -137,7 +77,7 @@ case "$#" in
 	log)
 		git bisect--helper --bisect-log || exit ;;
 	run)
-		bisect_run "$@" ;;
+		git bisect--helper --bisect-run "$@" || exit;;
 	terms)
 		git bisect--helper --bisect-terms "$@" || exit;;
 	*)
-- 
2.29.2

Re: [PATCH v5 5/6] bisect--helper: reimplement `bisect_run` shell function in C

From: Johannes Schindelin <hidden>
Date: 2021-08-24 13:59:24

Hi Miriam,

On Fri, 20 Aug 2021, Miriam Rubio wrote:
quoted hunk
From: Tanushree Tumane <redacted>

Reimplement the `bisect_run()` shell function
in C and also add `--bisect-run` subcommand to
`git bisect--helper` to call it from git-bisect.sh.

Mentored-by: Christian Couder [off-list ref]
Signed-off-by: Tanushree Tumane <redacted>
Signed-off-by: Miriam Rubio <redacted>
---
 builtin/bisect--helper.c | 102 +++++++++++++++++++++++++++++++++++++++
 git-bisect.sh            |  62 +-----------------------
 2 files changed, 103 insertions(+), 61 deletions(-)
diff --git a/builtin/bisect--helper.c b/builtin/bisect--helper.c
index 1e118a966a..8d33c809aa 100644
--- a/builtin/bisect--helper.c
+++ b/builtin/bisect--helper.c
@@ -18,6 +18,7 @@ static GIT_PATH_FUNC(git_path_bisect_log, "BISECT_LOG")
 static GIT_PATH_FUNC(git_path_head_name, "head-name")
 static GIT_PATH_FUNC(git_path_bisect_names, "BISECT_NAMES")
 static GIT_PATH_FUNC(git_path_bisect_first_parent, "BISECT_FIRST_PARENT")
+static GIT_PATH_FUNC(git_path_bisect_run, "BISECT_RUN")

 static const char * const git_bisect_helper_usage[] = {
 	N_("git bisect--helper --bisect-reset [<commit>]"),
@@ -31,6 +32,7 @@ static const char * const git_bisect_helper_usage[] = {
 	N_("git bisect--helper --bisect-replay <filename>"),
 	N_("git bisect--helper --bisect-skip [(<rev>|<range>)...]"),
 	N_("git bisect--helper --bisect-visualize"),
+	N_("git bisect--helper --bisect-run <cmd>..."),
 	NULL
 };
@@ -144,6 +146,25 @@ static int append_to_file(const char *path, const char *format, ...)
 	return res;
 }

+static int print_file_to_stdout(const char *path)
+{
+	FILE *fp;
+	char c;
+
+	fp = fopen(path, "r");
+	if (!fp)
+		return error_errno(_("cannot open file '%s' in read mode"), path);
+
+	c = fgetc(fp);
+	while (c != EOF) {
+		printf ("%c", c);
+		c = fgetc(fp);
+	}
+
+	fclose(fp);
Rather than reading byte for byte (even if buffered), how about using
`copy_fd()`? Something like

	int fd = open(path, O_RDONLY), ret = 0;

	if (fd < 0)
		return error_errno(_("cannot open file '%s' for reading"), path);
	if (copy_fd(fd, 1) < 0)
		ret = error_errno(_("failed to read '%s'"), path);
	close(fd);
	return ret;
quoted hunk
+	return 0;
+}
+
 static int check_term_format(const char *term, const char *orig_term)
 {
 	int res;
@@ -1075,6 +1096,78 @@ static int bisect_visualize(struct bisect_terms *terms, const char **argv, int a
 	return res;
 }

+static int bisect_run(struct bisect_terms *terms, const char **argv, int argc)
+{
+	int res = BISECT_OK;
+	struct strbuf command = STRBUF_INIT;
+	struct strvec args = STRVEC_INIT;
+	struct strvec run_args = STRVEC_INIT;
+	const char *new_state;
+	int temporary_stdout_fd, saved_stdout;
+
+	if (bisect_next_check(terms, NULL))
+		return BISECT_FAILED;
+
+	if (argc)
+		sq_quote_argv(&command, argv);
+	else {
+		error(_("bisect run failed: no command provided."));
+		return BISECT_FAILED;
+	}
+
+	strvec_push(&run_args, command.buf);
+
+	while (1) {
+		strvec_clear(&args);
+
+		printf(_("running %s\n"), command.buf);
+		res = run_command_v_opt(run_args.v, RUN_USING_SHELL);
+
+		if (res < 0 || 128 <= res) {
+			error(_("bisect run failed: exit code %d from"
+				" '%s' is < 0 or >= 128"), res, command.buf);
+			strbuf_release(&command);
+			return res;
+		}
+
+		if (res == 125)
+			new_state = "skip";
+		else new_state = res > 0 ? terms->term_bad : terms->term_good;
I do not care _all_ that much about formatting, but I think others on this
list do, and might point out that the `else` wants to live on its own
line.
+		temporary_stdout_fd = open(git_path_bisect_run(), O_CREAT | O_WRONLY | O_TRUNC, 0666);
+		saved_stdout = dup(1);
+		dup2(temporary_stdout_fd, 1);
This temporary redirection looks a bit iffy. I wonder whether there is a
way to tell `bisect_state()` to print to a given file descriptor, _in
addition to_ `stdout`? That would also make `print_file_to_stdout()`
obsolete.

What calls exactly are making that print to `stdout` anyway?

This is my only remaining issue with the current 5/6.

Thank you,
Dscho
quoted hunk
+
+		res = bisect_state(terms, &new_state, 1);
+
+		dup2(saved_stdout, 1);
+		close(saved_stdout);
+		close(temporary_stdout_fd);
+
+		print_file_to_stdout(git_path_bisect_run());
+
+		if (res == BISECT_ONLY_SKIPPED_LEFT)
+			error(_("bisect run cannot continue any more"));
+		else if (res == BISECT_INTERNAL_SUCCESS_MERGE_BASE) {
+			printf(_("bisect run success"));
+			res = BISECT_OK;
+		} else if (res == BISECT_INTERNAL_SUCCESS_1ST_BAD_FOUND) {
+			printf(_("bisect found first bad commit"));
+			res = BISECT_OK;
+		} else if (res) {
+			error(_("bisect run failed:'git bisect--helper --bisect-state"
+			" %s' exited with error code %d"), args.v[0], res);
+		} else {
+			continue;
+		}
+
+		strbuf_release(&command);
+		strvec_clear(&args);
+		strvec_clear(&run_args);
+		return res;
+	}
+}
+
 int cmd_bisect__helper(int argc, const char **argv, const char *prefix)
 {
 	enum {
@@ -1089,6 +1182,7 @@ int cmd_bisect__helper(int argc, const char **argv, const char *prefix)
 		BISECT_REPLAY,
 		BISECT_SKIP,
 		BISECT_VISUALIZE,
+		BISECT_RUN,
 	} cmdmode = 0;
 	int res = 0, nolog = 0;
 	struct option options[] = {
@@ -1112,6 +1206,8 @@ int cmd_bisect__helper(int argc, const char **argv, const char *prefix)
 			 N_("skip some commits for checkout"), BISECT_SKIP),
 		OPT_CMDMODE(0, "bisect-visualize", &cmdmode,
 			 N_("visualize the bisection"), BISECT_VISUALIZE),
+		OPT_CMDMODE(0, "bisect-run", &cmdmode,
+			 N_("use <cmd>... to automatically bisect."), BISECT_RUN),
 		OPT_BOOL(0, "no-log", &nolog,
 			 N_("no log for BISECT_WRITE")),
 		OPT_END()
@@ -1177,6 +1273,12 @@ int cmd_bisect__helper(int argc, const char **argv, const char *prefix)
 		get_terms(&terms);
 		res = bisect_visualize(&terms, argv, argc);
 		break;
+	case BISECT_RUN:
+		if (!argc)
+			return error(_("bisect run failed: no command provided."));
+		get_terms(&terms);
+		res = bisect_run(&terms, argv, argc);
+		break;
 	default:
 		BUG("unknown subcommand %d", cmdmode);
 	}
diff --git a/git-bisect.sh b/git-bisect.sh
index 95f7f3fb8c..e83d011e17 100755
--- a/git-bisect.sh
+++ b/git-bisect.sh
@@ -39,66 +39,6 @@ _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
 TERM_BAD=bad
 TERM_GOOD=good

-bisect_run () {
-	git bisect--helper --bisect-next-check $TERM_GOOD $TERM_BAD fail || exit
-
-	test -n "$*" || die "$(gettext "bisect run failed: no command provided.")"
-
-	while true
-	do
-		command="$@"
-		eval_gettextln "running \$command"
-		"$@"
-		res=$?
-
-		# Check for really bad run error.
-		if [ $res -lt 0 -o $res -ge 128 ]
-		then
-			eval_gettextln "bisect run failed:
-exit code \$res from '\$command' is < 0 or >= 128" >&2
-			exit $res
-		fi
-
-		# Find current state depending on run success or failure.
-		# A special exit code of 125 means cannot test.
-		if [ $res -eq 125 ]
-		then
-			state='skip'
-		elif [ $res -gt 0 ]
-		then
-			state="$TERM_BAD"
-		else
-			state="$TERM_GOOD"
-		fi
-
-		git bisect--helper --bisect-state $state >"$GIT_DIR/BISECT_RUN"
-		res=$?
-
-		cat "$GIT_DIR/BISECT_RUN"
-
-		if sane_grep "first $TERM_BAD commit could be any of" "$GIT_DIR/BISECT_RUN" \
-			>/dev/null
-		then
-			gettextln "bisect run cannot continue any more" >&2
-			exit $res
-		fi
-
-		if [ $res -ne 0 ]
-		then
-			eval_gettextln "bisect run failed:
-'bisect-state \$state' exited with error code \$res" >&2
-			exit $res
-		fi
-
-		if sane_grep "is the first $TERM_BAD commit" "$GIT_DIR/BISECT_RUN" >/dev/null
-		then
-			gettextln "bisect run success"
-			exit 0;
-		fi
-
-	done
-}
-
 get_terms () {
 	if test -s "$GIT_DIR/BISECT_TERMS"
 	then
@@ -137,7 +77,7 @@ case "$#" in
 	log)
 		git bisect--helper --bisect-log || exit ;;
 	run)
-		bisect_run "$@" ;;
+		git bisect--helper --bisect-run "$@" || exit;;
 	terms)
 		git bisect--helper --bisect-terms "$@" || exit;;
 	*)
--
2.29.2

Re: [PATCH v5 5/6] bisect--helper: reimplement `bisect_run` shell function in C

From: Miriam R. <hidden>
Date: 2021-08-26 16:46:30

Hi Johannes,


El mar, 24 ago 2021 a las 15:59, Johannes Schindelin
([off-list ref]) escribió:
Hi Miriam,

On Fri, 20 Aug 2021, Miriam Rubio wrote:
quoted
From: Tanushree Tumane <redacted>

Reimplement the `bisect_run()` shell function
in C and also add `--bisect-run` subcommand to
`git bisect--helper` to call it from git-bisect.sh.

Mentored-by: Christian Couder [off-list ref]
Signed-off-by: Tanushree Tumane <redacted>
Signed-off-by: Miriam Rubio <redacted>
---
 builtin/bisect--helper.c | 102 +++++++++++++++++++++++++++++++++++++++
 git-bisect.sh            |  62 +-----------------------
 2 files changed, 103 insertions(+), 61 deletions(-)
diff --git a/builtin/bisect--helper.c b/builtin/bisect--helper.c
index 1e118a966a..8d33c809aa 100644
--- a/builtin/bisect--helper.c
+++ b/builtin/bisect--helper.c
@@ -18,6 +18,7 @@ static GIT_PATH_FUNC(git_path_bisect_log, "BISECT_LOG")
 static GIT_PATH_FUNC(git_path_head_name, "head-name")
 static GIT_PATH_FUNC(git_path_bisect_names, "BISECT_NAMES")
 static GIT_PATH_FUNC(git_path_bisect_first_parent, "BISECT_FIRST_PARENT")
+static GIT_PATH_FUNC(git_path_bisect_run, "BISECT_RUN")

 static const char * const git_bisect_helper_usage[] = {
      N_("git bisect--helper --bisect-reset [<commit>]"),
@@ -31,6 +32,7 @@ static const char * const git_bisect_helper_usage[] = {
      N_("git bisect--helper --bisect-replay <filename>"),
      N_("git bisect--helper --bisect-skip [(<rev>|<range>)...]"),
      N_("git bisect--helper --bisect-visualize"),
+     N_("git bisect--helper --bisect-run <cmd>..."),
      NULL
 };
@@ -144,6 +146,25 @@ static int append_to_file(const char *path, const char *format, ...)
      return res;
 }

+static int print_file_to_stdout(const char *path)
+{
+     FILE *fp;
+     char c;
+
+     fp = fopen(path, "r");
+     if (!fp)
+             return error_errno(_("cannot open file '%s' in read mode"), path);
+
+     c = fgetc(fp);
+     while (c != EOF) {
+             printf ("%c", c);
+             c = fgetc(fp);
+     }
+
+     fclose(fp);
Rather than reading byte for byte (even if buffered), how about using
`copy_fd()`? Something like

        int fd = open(path, O_RDONLY), ret = 0;

        if (fd < 0)
                return error_errno(_("cannot open file '%s' for reading"), path);
        if (copy_fd(fd, 1) < 0)
                ret = error_errno(_("failed to read '%s'"), path);
        close(fd);
        return ret;
Ok. Noted.
quoted
+     return 0;
+}
+
 static int check_term_format(const char *term, const char *orig_term)
 {
      int res;
@@ -1075,6 +1096,78 @@ static int bisect_visualize(struct bisect_terms *terms, const char **argv, int a
      return res;
 }

+static int bisect_run(struct bisect_terms *terms, const char **argv, int argc)
+{
+     int res = BISECT_OK;
+     struct strbuf command = STRBUF_INIT;
+     struct strvec args = STRVEC_INIT;
+     struct strvec run_args = STRVEC_INIT;
+     const char *new_state;
+     int temporary_stdout_fd, saved_stdout;
+
+     if (bisect_next_check(terms, NULL))
+             return BISECT_FAILED;
+
+     if (argc)
+             sq_quote_argv(&command, argv);
+     else {
+             error(_("bisect run failed: no command provided."));
+             return BISECT_FAILED;
+     }
+
+     strvec_push(&run_args, command.buf);
+
+     while (1) {
+             strvec_clear(&args);
+
+             printf(_("running %s\n"), command.buf);
+             res = run_command_v_opt(run_args.v, RUN_USING_SHELL);
+
+             if (res < 0 || 128 <= res) {
+                     error(_("bisect run failed: exit code %d from"
+                             " '%s' is < 0 or >= 128"), res, command.buf);
+                     strbuf_release(&command);
+                     return res;
+             }
+
+             if (res == 125)
+                     new_state = "skip";
+             else new_state = res > 0 ? terms->term_bad : terms->term_good;
I do not care _all_ that much about formatting, but I think others on this
list do, and might point out that the `else` wants to live on its own
line.
Ok. I'll change that.
quoted
+             temporary_stdout_fd = open(git_path_bisect_run(), O_CREAT | O_WRONLY | O_TRUNC, 0666);
+             saved_stdout = dup(1);
+             dup2(temporary_stdout_fd, 1);
This temporary redirection looks a bit iffy. I wonder whether there is a
way to tell `bisect_state()` to print to a given file descriptor, _in
addition to_ `stdout`? That would also make `print_file_to_stdout()`
obsolete.

What calls exactly are making that print to `stdout` anyway?
I was trying to recreate the cat command with this solution as it is
in the shell script, without changing behavior or parameters in other
functions.
I think the most important prints to stdout come from
bisect_next_all() in bisect.c. The sequence is bisect_state()
->bisect_auto_next() ->  bisect_next() ->bisect_next_all().
Just to clarify: if we add a file descriptor as parameter in
bisect_state(), we have to propagate it to a lot of functions, is that
what we want?
This is my only remaining issue with the current 5/6.
Thank you for reviewing!
Miriam
Thank you,
Dscho
quoted
+
+             res = bisect_state(terms, &new_state, 1);
+
+             dup2(saved_stdout, 1);
+             close(saved_stdout);
+             close(temporary_stdout_fd);
+
+             print_file_to_stdout(git_path_bisect_run());
+
+             if (res == BISECT_ONLY_SKIPPED_LEFT)
+                     error(_("bisect run cannot continue any more"));
+             else if (res == BISECT_INTERNAL_SUCCESS_MERGE_BASE) {
+                     printf(_("bisect run success"));
+                     res = BISECT_OK;
+             } else if (res == BISECT_INTERNAL_SUCCESS_1ST_BAD_FOUND) {
+                     printf(_("bisect found first bad commit"));
+                     res = BISECT_OK;
+             } else if (res) {
+                     error(_("bisect run failed:'git bisect--helper --bisect-state"
+                     " %s' exited with error code %d"), args.v[0], res);
+             } else {
+                     continue;
+             }
+
+             strbuf_release(&command);
+             strvec_clear(&args);
+             strvec_clear(&run_args);
+             return res;
+     }
+}
+
 int cmd_bisect__helper(int argc, const char **argv, const char *prefix)
 {
      enum {
@@ -1089,6 +1182,7 @@ int cmd_bisect__helper(int argc, const char **argv, const char *prefix)
              BISECT_REPLAY,
              BISECT_SKIP,
              BISECT_VISUALIZE,
+             BISECT_RUN,
      } cmdmode = 0;
      int res = 0, nolog = 0;
      struct option options[] = {
@@ -1112,6 +1206,8 @@ int cmd_bisect__helper(int argc, const char **argv, const char *prefix)
                       N_("skip some commits for checkout"), BISECT_SKIP),
              OPT_CMDMODE(0, "bisect-visualize", &cmdmode,
                       N_("visualize the bisection"), BISECT_VISUALIZE),
+             OPT_CMDMODE(0, "bisect-run", &cmdmode,
+                      N_("use <cmd>... to automatically bisect."), BISECT_RUN),
              OPT_BOOL(0, "no-log", &nolog,
                       N_("no log for BISECT_WRITE")),
              OPT_END()
@@ -1177,6 +1273,12 @@ int cmd_bisect__helper(int argc, const char **argv, const char *prefix)
              get_terms(&terms);
              res = bisect_visualize(&terms, argv, argc);
              break;
+     case BISECT_RUN:
+             if (!argc)
+                     return error(_("bisect run failed: no command provided."));
+             get_terms(&terms);
+             res = bisect_run(&terms, argv, argc);
+             break;
      default:
              BUG("unknown subcommand %d", cmdmode);
      }
diff --git a/git-bisect.sh b/git-bisect.sh
index 95f7f3fb8c..e83d011e17 100755
--- a/git-bisect.sh
+++ b/git-bisect.sh
@@ -39,66 +39,6 @@ _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
 TERM_BAD=bad
 TERM_GOOD=good

-bisect_run () {
-     git bisect--helper --bisect-next-check $TERM_GOOD $TERM_BAD fail || exit
-
-     test -n "$*" || die "$(gettext "bisect run failed: no command provided.")"
-
-     while true
-     do
-             command="$@"
-             eval_gettextln "running \$command"
-             "$@"
-             res=$?
-
-             # Check for really bad run error.
-             if [ $res -lt 0 -o $res -ge 128 ]
-             then
-                     eval_gettextln "bisect run failed:
-exit code \$res from '\$command' is < 0 or >= 128" >&2
-                     exit $res
-             fi
-
-             # Find current state depending on run success or failure.
-             # A special exit code of 125 means cannot test.
-             if [ $res -eq 125 ]
-             then
-                     state='skip'
-             elif [ $res -gt 0 ]
-             then
-                     state="$TERM_BAD"
-             else
-                     state="$TERM_GOOD"
-             fi
-
-             git bisect--helper --bisect-state $state >"$GIT_DIR/BISECT_RUN"
-             res=$?
-
-             cat "$GIT_DIR/BISECT_RUN"
-
-             if sane_grep "first $TERM_BAD commit could be any of" "$GIT_DIR/BISECT_RUN" \
-                     >/dev/null
-             then
-                     gettextln "bisect run cannot continue any more" >&2
-                     exit $res
-             fi
-
-             if [ $res -ne 0 ]
-             then
-                     eval_gettextln "bisect run failed:
-'bisect-state \$state' exited with error code \$res" >&2
-                     exit $res
-             fi
-
-             if sane_grep "is the first $TERM_BAD commit" "$GIT_DIR/BISECT_RUN" >/dev/null
-             then
-                     gettextln "bisect run success"
-                     exit 0;
-             fi
-
-     done
-}
-
 get_terms () {
      if test -s "$GIT_DIR/BISECT_TERMS"
      then
@@ -137,7 +77,7 @@ case "$#" in
      log)
              git bisect--helper --bisect-log || exit ;;
      run)
-             bisect_run "$@" ;;
+             git bisect--helper --bisect-run "$@" || exit;;
      terms)
              git bisect--helper --bisect-terms "$@" || exit;;
      *)
--
2.29.2

[PATCH v5 6/6] bisect--helper: retire `--bisect-next-check` subcommand

From: Miriam Rubio <hidden>
Date: 2021-08-20 17:23:15

After reimplementation of `git bisect run` in C,
`--bisect-next-check` subcommand is not needed anymore.

Let's remove it from options list and code.

Mentored by: Christian Couder [off-list ref]
Signed-off-by: Miriam Rubio <redacted>
---
 builtin/bisect--helper.c | 7 -------
 1 file changed, 7 deletions(-)
diff --git a/builtin/bisect--helper.c b/builtin/bisect--helper.c
index 8d33c809aa..6e1e7c243d 100644
--- a/builtin/bisect--helper.c
+++ b/builtin/bisect--helper.c
@@ -22,7 +22,6 @@ static GIT_PATH_FUNC(git_path_bisect_run, "BISECT_RUN")
 
 static const char * const git_bisect_helper_usage[] = {
 	N_("git bisect--helper --bisect-reset [<commit>]"),
-	N_("git bisect--helper --bisect-next-check <good_term> <bad_term> [<term>]"),
 	N_("git bisect--helper --bisect-terms [--term-good | --term-old | --term-bad | --term-new]"),
 	N_("git bisect--helper --bisect-start [--term-{new,bad}=<term> --term-{old,good}=<term>]"
 					    " [--no-checkout] [--first-parent] [<bad> [<good>...]] [--] [<paths>...]"),
@@ -1227,12 +1226,6 @@ int cmd_bisect__helper(int argc, const char **argv, const char *prefix)
 			return error(_("--bisect-reset requires either no argument or a commit"));
 		res = bisect_reset(argc ? argv[0] : NULL);
 		break;
-	case BISECT_NEXT_CHECK:
-		if (argc != 2 && argc != 3)
-			return error(_("--bisect-next-check requires 2 or 3 arguments"));
-		set_terms(&terms, argv[1], argv[0]);
-		res = bisect_next_check(&terms, argc == 3 ? argv[2] : NULL);
-		break;
 	case BISECT_TERMS:
 		if (argc > 1)
 			return error(_("--bisect-terms requires 0 or 1 argument"));
-- 
2.29.2

Re: [PATCH v5 0/6] Finish converting git bisect to C part 4

From: Johannes Schindelin <hidden>
Date: 2021-08-24 14:00:16

Hi Miriam,

On Fri, 20 Aug 2021, Miriam Rubio wrote:
These patches correspond to a fourth part of patch series
of Outreachy project "Finish converting `git bisect` from shell to C"
started by Pranit Bauva and Tanushree Tumane
(https://public-inbox.org/git/pull.117.git.gitgitgadget@gmail.com) and
continued by me.

This fourth part is formed by reimplementations of some `git bisect`
subcommands, addition of tests and removal of some temporary subcommands.

These patch series emails were generated from:
https://gitlab.com/mirucam/git/commits/git-bisect-work-part4-v5.
Apart from the stdout redirection in 5/6, the patches look really stable
to me.

Thanks,
Dscho
I would like to thank Johannes Schindelin, Bagas Sanjaya and
Christian Couder for reviewing this patch series.

Specific changes
----------------
[1/6] t6030-bisect-porcelain: add tests to control bisect run exit cases
* Add evaluation of error code 255 in test 'bisect run fails with exit
code equals or greater than 128'.
* Remove test with error code smaller than 0.
---

[4/6] bisect--helper: reimplement `bisect_visualize()`shell function in C
* Use strvec_push() instead of strvec_pushl().
---

[5/6] bisect--helper: reimplement `bisect_run` shell function in C
* Add error message.
* Remove exit variable.
* Write contents of bisect_state() in BISECT_RUN file and show to user.
---

Miriam Rubio (3):
  t6030-bisect-porcelain: add tests to control bisect run exit cases
  t6030-bisect-porcelain: add test for bisect visualize
  bisect--helper: retire `--bisect-next-check` subcommand

Pranit Bauva (2):
  run-command: make `exists_in_PATH()` non-static
  bisect--helper: reimplement `bisect_visualize()`shell function in C

Tanushree Tumane (1):
  bisect--helper: reimplement `bisect_run` shell function in C

 builtin/bisect--helper.c    | 157 ++++++++++++++++++++++++++++++++++--
 git-bisect.sh               |  87 +-------------------
 run-command.c               |   2 +-
 run-command.h               |  12 +++
 t/t6030-bisect-porcelain.sh |  18 +++++
 5 files changed, 182 insertions(+), 94 deletions(-)

--
2.29.2
Keyboard shortcuts
hback out one level
jnext message in thread
kprevious message in thread
ldrill in
Escclose help / fold thread tree
?toggle this help